<template>
  <q-select
    borderless
    transition-show="jump-down"
    transition-hide="jump-up"
    v-model="selectedLanguage"
    :options="listOfLanguages"
    dense
    emit-value
    hide-dropdown-icon
    class="language-select"
    @input="changeLanguage()"
    @popup-show="rotateIcon = true"
    @popup-hide="rotateIcon = false"
  >
    <template v-slot:selected>
      <span class="language-select__selected">
       {{ selectedLanguage }}
      </span>
    </template>

    <template v-slot:append>
      <iconBase
        :class="['language-select__icon', { 'rotate-icon': rotateIcon }]"
        icon-name="arrowDown"
        viewBoxX="12" viewBoxY="8"
      >
        <arrowDown />
      </iconBase>
    </template>

    <template v-slot:option="scope">
      <q-item
        v-bind="scope.itemProps"
        v-on="scope.itemEvents"
        class="language-select__options"
      >
        <iconBase
          class="language-select__flag-icon"
          :icon-name="scope.opt.icon"
        >
          <span :is="scope.opt.icon" />
        </iconBase>
        <div class="language-select__options--text">
          {{ scope.opt.label }}
          </div>
      </q-item>
    </template>
  </q-select>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api'
import ChangeLanguageInQuasar from '../mixins/changeLanguageInQuasar'
import flagRu from 'components/icons/flagRussia.vue'
import flagEn from 'components/icons/flagEnglish.vue'
import arrowDown from 'components/icons/arrowDown.vue'

export default defineComponent({
  name: 'SelectLanguage',

  components: {
    'flag-ru-ru': flagRu,
    'flag-en-gb': flagEn,
    arrowDown
  },

  setup (props, { root }) {
    const rotateIcon = ref(false)
    const selectedLanguage = ref('')
    const isoForSelectedLanguage = {
      'en-gb': 'EN',
      'ru-ru': 'RU'
    }
    const listOfLanguages = [
      {
        label: 'EN',
        value: 'EN',
        icon: 'flag-en-gb'
      },
      {
        label: 'RU',
        value: 'RU',
        icon: 'flag-ru-ru'
      }
    ]

    // Оператор || или нужен, для того, если язык не будет определён автоматически (this.$i18n.locale выдаст undefined), то подставляем по дефолту английский
    selectedLanguage.value = isoForSelectedLanguage[root.$i18n.locale] || isoForSelectedLanguage['en-gb']

    const changeLanguage = () => {
      const isoI18n = {
        EN: 'en-gb',
        RU: 'ru-ru'
      }

      root.$i18n.locale = isoI18n[selectedLanguage.value]
      root.$store.dispatch('main/isoLanguage', isoI18n[selectedLanguage.value])

      ChangeLanguageInQuasar(root)

      root.$q.cookies.set('localization', { localization: root.$i18n.locale }, { path: '/' })
    }

    return { selectedLanguage, listOfLanguages, changeLanguage, rotateIcon }
  }
})
</script>

<style lang="scss" scoped>
 @import '../css/variables';

.language-select {
  padding: 5px;
  width: 60px;
  height: 26px;
  text-align: center;
  border: 2px solid #cfd4d7;
  border-radius: 10px;
  cursor: pointer;

  &__icon {
    height: 14px;
    min-height: 14px; // нужно для Safari - Без этого высота иконки в Safari была 3px
    width: 14px;
    fill: $brandColorGray;
    animation: rotateBack .5s ease both;
  }

  &__options {
    display: flex;
    align-items: center;

    svg {
      width: 24px;
      margin-right: 8px;
    }

    &--text {
      color: $brandColorGray;
    }
  }

  &__selected {
    color: $brandColorGray;
  }
}

.rotate-icon {
  animation: rotate .5s ease both;
}

@keyframes rotate {
  from { transform: rotate(0deg); }
  to { transform: rotate(180deg); }
}

@keyframes rotateBack {
  from { transform: rotate(180deg); }
  to { transform: rotate(0deg); }
}
</style>
